
/* ***************************************************
	FILE:  GEMAL.java.ux
	PROJECT:
		Turtle Tracks
	PROGRAMMERS:
		Daniel Azuma (DA)  <dazuma@kagi.com>
		
	Mon Jul 11 15:18:58 CDT 2005
		AUGMENTATION BY  Levi Yourchuck
		Major refactoring to ensue.
		
	COPYRIGHT:
		Copyright (C) 1997-1999  Daniel Azuma  (dazuma@kagi.com)
		
		Copyright (C) 2005 - 2013 Levi Yourchuck (levi_yourchuck@yahoo.com)
		Copyright (C) 2013 -       Levi Yourchuck (levi_yourchuck@yahoo.com)

		This program is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License
		as published by the Free Software Foundation; either version 2
		of the License, or (at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public
		License along with this program. If not, you can obtain a copy
		by writing to:
			Free Software Foundation, Inc.
			59 Temple Place - Suite 330,
			Boston, MA  02111-1307, USA.
		
	VERSION:
		Turtle Tracks 1.0  (13 November 1999)
	CHANGE HISTORY:
		13 November 1999 -- DA -- Released under GNU General Public License
*************************************************** */
package virtuoso.logo.app;

// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
// turtle_tracks_imports
import virtuoso.logo.*;
import virtuoso.logo.app.*;
import virtuoso.logo.app.actions.*;
import virtuoso.logo.lib.*;
import virtuoso.logo.file.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.util.*;
import java.util.zip.*;
import java.io.*;
import java.text.*;
import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
/**
	GEMAL GEMAL GEMAL GEMAL GEMAL GEMAL GEMAL
	GuiEditorMenu ActionListener
*/
public class GEMAL
implements ActionListener
{
	public Action EVAL_PROCEDURES_ACTION = new AbstractAction() {
		public void actionPerformed( final ActionEvent e ) {
			getEditorPanel().acceptEdits();
		}
	};


	public void setEditorPanel( GuiEditorPanel editorPanel ) {
		_editorPanel = editorPanel;
	}
	private GuiEditorPanel _editorPanel;
	public final GuiEditorPanel getEditorPanel() {
		return _editorPanel;
	}
	
	public JFrame getJFrame() { return _f; }
	public void setJFrame( final JFrame f ) { _f = f; }
	private JFrame _f;
	
	public void actionPerformed( ActionEvent event) {
		String cmd = event.getActionCommand();
		System.out.println("cmd:"+cmd+"<:|:>"+"virtuoso.logo.app.GEMAL.java.ux:TL-93");
		if( cmd == null ) {
			return;
		}
		if (cmd.equals("ACCP")) {
			EVAL_PROCEDURES_ACTION.actionPerformed( null );
		}
		else if (cmd.equals("CLAC")) {
			EVAL_PROCEDURES_ACTION.actionPerformed( null );
			_editorPanel._guiConsole._editors.removeElement(this);
			System.out.println("Mon Jul 18 01:40:17 CDT 2005, removed dispose(), don't think thi s is needed...."+"<:|:>"+"virtuoso.logo.app.GEMAL.java.ux:TL-103");
			//getJFrame().dispose();
		}
		else if (cmd.equals("CLDS")) {
			_editorPanel._guiConsole._editors.removeElement(this);
			System.out.println("Mon Jul 18 01:40:17 CDT 2005, removed dispose(), don't think thi s is needed...."+"<:|:>"+"virtuoso.logo.app.GEMAL.java.ux:TL-108");
			//getJFrame().dispose();
		}
		else if (cmd.equals("SAVE")) {
			//_editorPanel.saveToFile();
			System.out.println("i didn't know this was stillactive code"+"<:|:>"+"virtuoso.logo.app.GEMAL.java.ux:TL-113");
		}
		else if (cmd.equals("QUIT")) {
			System.out.println("here is this?????"+"<:|:>"+"virtuoso.logo.app.GEMAL.java.ux:TL-116");
			final boolean proceed = new HandleModifiedProceduresAction(_editorPanel._guiConsole).execute();
			if( proceed ) {
				int result = MessageWind.execute( MessageWind.genStrings("Are you sure you want to quit PowerMath Logo?"), MessageWind.genStrings("Quit", "Cancel"), getJFrame() );
				if (result == 0) {
					_editorPanel._guiConsole.goodbye();
					_editorPanel._guiConsole.mach().terminateAllThreads();
					_editorPanel._guiConsole.pushBuffer(new String());
				}
			}
		}
		
		else if (cmd.equals("UNDO")) {
		}
		/*
		else if (cmd.equals("CUT ")) {
		
			int selStart = _editorPanel._textArea.getSelectionStart();
			int selEnd = _editorPanel._textArea.getSelectionEnd();
			StringSelection sel = new StringSelection(
				_editorPanel._textArea.getText().substring(selStart, selEnd));
			try {
				getJFrame().getToolkit().getSystemClipboard().setContents(sel, sel);
			}
			catch (SecurityException e) {
				_editorPanel._guiConsole._clipboard.setContents(sel, sel);
			}
			_editorPanel._textArea.replaceRange(new String(), selStart, selEnd);
			_editorPanel._textArea.setCaretPosition(selStart);
			_editorPanel._textArea.select(selStart, selStart);
		
		}
		else if (cmd.equals("COPY")) {
			StringSelection sel = new StringSelection(_editorPanel._textArea.getSelectedText());
			try {
				getJFrame().getToolkit().getSystemClipboard().setContents(sel, sel);
			}
			catch (SecurityException e) {
				_editorPanel._guiConsole._clipboard.setContents(sel, sel);
			}
		}
		else if (cmd.equals("PAST")) {
			try {
				String toPaste;
				try {
					Transferable trans = getJFrame().getToolkit().getSystemClipboard().getContents(this);
					toPaste = (String)(trans.getTransferData(DataFlavor.stringFlavor));
				}
				catch (SecurityException e) {
					Transferable trans = _editorPanel._guiConsole._clipboard.getContents(this);
					toPaste = (String)(trans.getTransferData(DataFlavor.stringFlavor));
				}
				int selStart = _editorPanel._textArea.getSelectionStart();
				int afterPos = selStart + toPaste.length();
				_editorPanel._textArea.replaceRange(toPaste, selStart, _editorPanel._textArea.getSelectionEnd());
				_editorPanel._textArea.setCaretPosition(afterPos);
				_editorPanel._textArea.select(afterPos, afterPos);
			}
			catch (UnsupportedFlavorException e) {}
			catch (IOException e) {}
		}
		
		else if (cmd.equals("CLER")) {
			int pos = _editorPanel._textArea.getSelectionStart();
			_editorPanel._textArea.replaceRange(new String(), pos, _editorPanel._textArea.getSelectionEnd());
			_editorPanel._textArea.setCaretPosition(pos);
			_editorPanel._textArea.select(pos, pos);
		}
		*/
	}
}