
/* ***************************************************
	FILE:  App2005.java.ux
	PROJECT:
		Turtle Tracks
	PROGRAMMERS:
		Daniel Azuma (DA)  <dazuma@kagi.com>
		
	Mon Jul 11 15:18:58 CDT 2005
		AUGMENTATION BY  Levi Yourchuck
		Major refactoring to ensue.
		
	COPYRIGHT:
		Copyright (C) 1997-1999  Daniel Azuma  (dazuma@kagi.com)
		
		Copyright (C) 2005 - 2013 Levi Yourchuck (levi_yourchuck@yahoo.com)
		Copyright (C) 2013 -       Levi Yourchuck (levi_yourchuck@yahoo.com)

		This program is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License
		as published by the Free Software Foundation; either version 2
		of the License, or (at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public
		License along with this program. If not, you can obtain a copy
		by writing to:
			Free Software Foundation, Inc.
			59 Temple Place - Suite 330,
			Boston, MA  02111-1307, USA.
		
	VERSION:
		Turtle Tracks 1.0  (13 November 1999)
	CHANGE HISTORY:
		13 November 1999 -- DA -- Released under GNU General Public License
*************************************************** */
package virtuoso.logo.app;


// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
// turtle_tracks_imports
import virtuoso.logo.*;
import virtuoso.logo.app.*;
import virtuoso.logo.app.actions.*;
import virtuoso.logo.lib.*;
import virtuoso.logo.file.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.util.*;
import java.util.zip.*;
import java.io.*;
import java.text.*;
import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
/**
	
	ok, simple test to narrow down weird no cursor problem
	
	
	
*/
public class App2005 
{
	
	public static final void main( final String[] args ) {
		
		JFrame frame = new JFrame();
		frame.setTitle( "is the focus in the text area 2 " );
		
		JPanel panel = new JPanel();
		panel.setLayout( new GridLayout( 2, 1 ) );
		
		
		JTextArea t1 = new JTextArea();
		t1.setBackground( Color.red );
		
		JTextArea t2 = new JTextArea();
		t2.setBackground( Color.yellow );
		
		
		panel.add( t1 );
		panel.add( t2 );
		
		
		frame.getContentPane().setLayout( new BorderLayout() );
		frame.getContentPane().add( panel, BorderLayout.CENTER );
		
		frame.show();
		
		t1.setText( "text area 1" );
		t2.setText( "text area 2" );
		
		//Sun Jul 31 04:27:28 CDT 2005
		// NO
		
		
		t2.requestFocus();
		
		// Sun Jul 31 04:27:52 CDT 2005
		// YES
		
		t1.setText( t1.getText() + "\n" + "some more text" );
		
		// Sun Jul 31 04:29:13 CDT 2005
		// it is still there after setting the text on another component...hmm what could be causing the problem in the main turtle tracks app...
		
		
		
		
		
	}
	
	
}