
/* ***************************************************
	FILE:  MenuCommands.java.ux
	PROJECT:
		Turtle Tracks
	PROGRAMMERS:
		Daniel Azuma (DA)  <dazuma@kagi.com>
		
	Mon Jul 11 15:18:58 CDT 2005
		AUGMENTATION BY  Levi Yourchuck
		Major refactoring to ensue.
		
	COPYRIGHT:
		Copyright (C) 1997-1999  Daniel Azuma  (dazuma@kagi.com)
		
		Copyright (C) 2005 - 2013 Levi Yourchuck (levi_yourchuck@yahoo.com)
		Copyright (C) 2013 -       Levi Yourchuck (levi_yourchuck@yahoo.com)

		This program is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License
		as published by the Free Software Foundation; either version 2
		of the License, or (at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public
		License along with this program. If not, you can obtain a copy
		by writing to:
			Free Software Foundation, Inc.
			59 Temple Place - Suite 330,
			Boston, MA  02111-1307, USA.
		
	VERSION:
		Turtle Tracks 1.0  (13 November 1999)
	CHANGE HISTORY:
		13 November 1999 -- DA -- Released under GNU General Public License
*************************************************** */
package virtuoso.logo.app;

// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
// turtle_tracks_imports
import virtuoso.logo.*;
import virtuoso.logo.app.*;
import virtuoso.logo.app.actions.*;
import virtuoso.logo.lib.*;
import virtuoso.logo.file.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.util.*;
import java.util.zip.*;
import java.io.*;
import java.text.*;
import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

/**
	Just a bunch of static definitions.
*/
public class MenuCommands
{
	public static final String NEW = "NEW";
	public static final String OPEN = "OPEN";
	public static final String QUIT = "QUIT";
	
	public static final String SAVE = "SAVE";
	public static final String SAVE_AS = "SAVE_AS";
	public static final String SAVE_AS_IMAGE = "SAVE_AS_IMAGE";
	public static final String CLOSE = "CLOSE";
	
	
	
	public static final String LOAD_PROCEDURES = "LOAD_PROCEDURES";
	public static final String SAVE_PROCEDURES = "SAVE_PROCEDURES";
	
	public static final String OPEN_GRAPHICS = "OPEN_GRAPHICS";
	
	public static final String UNDO = "UNDO";
	public static final String CUT = "CUT";
	public static final String COPY = "COPY";
	public static final String PASTE = "PASTE";
	public static final String CLEAR = "CLEAR";
	public static final String CLEAR_HISTORY = "CLEAR_HISTORY";
	public static final String RESET_ENV = "RESET_ENV";
	public static final String INTERRUPT = "INTERRUPT";
	public static final String PAUSE = "PAUSE";
	
	public static final String SHOW_TUTORIAL = "SHOW_TUTORIAL";
	
}