
/* ***************************************************
	FILE:  MyApplication.java.ux
	PROJECT:
		Turtle Tracks
	PROGRAMMERS:
		Daniel Azuma (DA)  <dazuma@kagi.com>
		
	Mon Jul 11 15:18:58 CDT 2005
		AUGMENTATION BY  Levi Yourchuck
		Major refactoring to ensue.
		
	COPYRIGHT:
		Copyright (C) 1997-1999  Daniel Azuma  (dazuma@kagi.com)
		
		Copyright (C) 2005 - 2013 Levi Yourchuck (levi_yourchuck@yahoo.com)
		Copyright (C) 2013 -       Levi Yourchuck (levi_yourchuck@yahoo.com)

		This program is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License
		as published by the Free Software Foundation; either version 2
		of the License, or (at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public
		License along with this program. If not, you can obtain a copy
		by writing to:
			Free Software Foundation, Inc.
			59 Temple Place - Suite 330,
			Boston, MA  02111-1307, USA.
		
	VERSION:
		Turtle Tracks 1.0  (13 November 1999)
	CHANGE HISTORY:
		13 November 1999 -- DA -- Released under GNU General Public License
*************************************************** */
package virtuoso.splash;

import javax.swing.*;
import java.lang.reflect.*;

/**

*/
public class MyApplication
{
	/**
		Starts the application and returns when it is ready to use.
		@param args the command line arguments
	*/
	public static void main(String[] args) {
		try {
			SwingUtilities.invokeAndWait(new Runnable() {
				public void run() {
					JFrame f = new JFrame("My Application");
					//f.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
					f.getContentPane().add(new JLabel("Hello World"));
					f.pack();
					f.show();
				}
			});
		} catch (InterruptedException e) {
			// Ignore: If this exception occurs, we return too early, which makes the splash window go away too early.  Nothing to worry about. Maybe we should write a log message.
		} catch (InvocationTargetException e) {
			// Error: Startup has failed badly.  We can not continue running our application.
			java.lang.InternalError error = new java.lang.InternalError(e.toString());
			//error.initCause(e);
			throw error;
		}
	}
}